ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/AnyEvent/lib/AnyEvent.pm
(Generate patch)

Comparing AnyEvent/lib/AnyEvent.pm (file contents):
Revision 1.198 by root, Thu Mar 26 20:17:44 2009 UTC vs.
Revision 1.211 by root, Sat Jun 6 12:04:30 2009 UTC

1=head1 NAME 1=head1 NAME
2 2
3AnyEvent - provide framework for multiple event loops 3AnyEvent - provide framework for multiple event loops
4 4
5EV, Event, Glib, Tk, Perl, Event::Lib, Qt, POE - various supported event loops 5EV, Event, Glib, Tk, Perl, Event::Lib, Qt and POE are various supported
6event loops.
6 7
7=head1 SYNOPSIS 8=head1 SYNOPSIS
8 9
9 use AnyEvent; 10 use AnyEvent;
10 11
12 # file descriptor readable
11 my $w = AnyEvent->io (fh => $fh, poll => "r|w", cb => sub { ... }); 13 my $w = AnyEvent->io (fh => $fh, poll => "r", cb => sub { ... });
12 14
15 # one-shot or repeating timers
13 my $w = AnyEvent->timer (after => $seconds, cb => sub { ... }); 16 my $w = AnyEvent->timer (after => $seconds, cb => sub { ... });
14 my $w = AnyEvent->timer (after => $seconds, interval => $seconds, cb => ... 17 my $w = AnyEvent->timer (after => $seconds, interval => $seconds, cb => ...
15 18
16 print AnyEvent->now; # prints current event loop time 19 print AnyEvent->now; # prints current event loop time
17 print AnyEvent->time; # think Time::HiRes::time or simply CORE::time. 20 print AnyEvent->time; # think Time::HiRes::time or simply CORE::time.
18 21
22 # POSIX signal
19 my $w = AnyEvent->signal (signal => "TERM", cb => sub { ... }); 23 my $w = AnyEvent->signal (signal => "TERM", cb => sub { ... });
20 24
25 # child process exit
21 my $w = AnyEvent->child (pid => $pid, cb => sub { 26 my $w = AnyEvent->child (pid => $pid, cb => sub {
22 my ($pid, $status) = @_; 27 my ($pid, $status) = @_;
23 ... 28 ...
24 }); 29 });
30
31 # called when event loop idle (if applicable)
32 my $w = AnyEvent->idle (cb => sub { ... });
25 33
26 my $w = AnyEvent->condvar; # stores whether a condition was flagged 34 my $w = AnyEvent->condvar; # stores whether a condition was flagged
27 $w->send; # wake up current and all future recv's 35 $w->send; # wake up current and all future recv's
28 $w->recv; # enters "main loop" till $condvar gets ->send 36 $w->recv; # enters "main loop" till $condvar gets ->send
29 # use a condvar in callback mode: 37 # use a condvar in callback mode:
168=head2 I/O WATCHERS 176=head2 I/O WATCHERS
169 177
170You can create an I/O watcher by calling the C<< AnyEvent->io >> method 178You can create an I/O watcher by calling the C<< AnyEvent->io >> method
171with the following mandatory key-value pairs as arguments: 179with the following mandatory key-value pairs as arguments:
172 180
173C<fh> the Perl I<file handle> (I<not> file descriptor) to watch for events 181C<fh> is the Perl I<file handle> (I<not> file descriptor) to watch
174(AnyEvent might or might not keep a reference to this file handle). C<poll> 182for events (AnyEvent might or might not keep a reference to this file
183handle). Note that only file handles pointing to things for which
184non-blocking operation makes sense are allowed. This includes sockets,
185most character devices, pipes, fifos and so on, but not for example files
186or block devices.
187
175must be a string that is either C<r> or C<w>, which creates a watcher 188C<poll> must be a string that is either C<r> or C<w>, which creates a
176waiting for "r"eadable or "w"ritable events, respectively. C<cb> is the 189watcher waiting for "r"eadable or "w"ritable events, respectively.
190
177callback to invoke each time the file handle becomes ready. 191C<cb> is the callback to invoke each time the file handle becomes ready.
178 192
179Although the callback might get passed parameters, their value and 193Although the callback might get passed parameters, their value and
180presence is undefined and you cannot rely on them. Portable AnyEvent 194presence is undefined and you cannot rely on them. Portable AnyEvent
181callbacks cannot use arguments passed to I/O watcher callbacks. 195callbacks cannot use arguments passed to I/O watcher callbacks.
182 196
313 327
314In either case, if you care (and in most cases, you don't), then you 328In either case, if you care (and in most cases, you don't), then you
315can get whatever behaviour you want with any event loop, by taking the 329can get whatever behaviour you want with any event loop, by taking the
316difference between C<< AnyEvent->time >> and C<< AnyEvent->now >> into 330difference between C<< AnyEvent->time >> and C<< AnyEvent->now >> into
317account. 331account.
332
333=item AnyEvent->now_update
334
335Some event loops (such as L<EV> or L<AnyEvent::Impl::Perl>) cache
336the current time for each loop iteration (see the discussion of L<<
337AnyEvent->now >>, above).
338
339When a callback runs for a long time (or when the process sleeps), then
340this "current" time will differ substantially from the real time, which
341might affect timers and time-outs.
342
343When this is the case, you can call this method, which will update the
344event loop's idea of "current time".
345
346Note that updating the time I<might> cause some events to be handled.
318 347
319=back 348=back
320 349
321=head2 SIGNAL WATCHERS 350=head2 SIGNAL WATCHERS
322 351
389 ); 418 );
390 419
391 # do something else, then wait for process exit 420 # do something else, then wait for process exit
392 $done->recv; 421 $done->recv;
393 422
423=head2 IDLE WATCHERS
424
425Sometimes there is a need to do something, but it is not so important
426to do it instantly, but only when there is nothing better to do. This
427"nothing better to do" is usually defined to be "no other events need
428attention by the event loop".
429
430Idle watchers ideally get invoked when the event loop has nothing
431better to do, just before it would block the process to wait for new
432events. Instead of blocking, the idle watcher is invoked.
433
434Most event loops unfortunately do not really support idle watchers (only
435EV, Event and Glib do it in a usable fashion) - for the rest, AnyEvent
436will simply call the callback "from time to time".
437
438Example: read lines from STDIN, but only process them when the
439program is otherwise idle:
440
441 my @lines; # read data
442 my $idle_w;
443 my $io_w = AnyEvent->io (fh => \*STDIN, poll => 'r', cb => sub {
444 push @lines, scalar <STDIN>;
445
446 # start an idle watcher, if not already done
447 $idle_w ||= AnyEvent->idle (cb => sub {
448 # handle only one line, when there are lines left
449 if (my $line = shift @lines) {
450 print "handled when idle: $line";
451 } else {
452 # otherwise disable the idle watcher again
453 undef $idle_w;
454 }
455 });
456 });
457
394=head2 CONDITION VARIABLES 458=head2 CONDITION VARIABLES
395 459
396If you are familiar with some event loops you will know that all of them 460If you are familiar with some event loops you will know that all of them
397require you to run some blocking "loop", "run" or similar function that 461require you to run some blocking "loop", "run" or similar function that
398will actively watch for new events and call your callbacks. 462will actively watch for new events and call your callbacks.
867no warnings; 931no warnings;
868use strict qw(vars subs); 932use strict qw(vars subs);
869 933
870use Carp; 934use Carp;
871 935
872our $VERSION = 4.341; 936our $VERSION = 4.41;
873our $MODEL; 937our $MODEL;
874 938
875our $AUTOLOAD; 939our $AUTOLOAD;
876our @ISA; 940our @ISA;
877 941
909 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza 973 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza
910 [Wx:: => AnyEvent::Impl::POE::], 974 [Wx:: => AnyEvent::Impl::POE::],
911 [Prima:: => AnyEvent::Impl::POE::], 975 [Prima:: => AnyEvent::Impl::POE::],
912); 976);
913 977
914our %method = map +($_ => 1), qw(io timer time now signal child condvar one_event DESTROY); 978our %method = map +($_ => 1),
979 qw(io timer time now now_update signal child idle condvar one_event DESTROY);
915 980
916our @post_detect; 981our @post_detect;
917 982
918sub post_detect(&) { 983sub post_detect(&) {
919 my ($cb) = @_; 984 my ($cb) = @_;
924 1 989 1
925 } else { 990 } else {
926 push @post_detect, $cb; 991 push @post_detect, $cb;
927 992
928 defined wantarray 993 defined wantarray
929 ? bless \$cb, "AnyEvent::Util::PostDetect" 994 ? bless \$cb, "AnyEvent::Util::postdetect"
930 : () 995 : ()
931 } 996 }
932} 997}
933 998
934sub AnyEvent::Util::PostDetect::DESTROY { 999sub AnyEvent::Util::postdetect::DESTROY {
935 @post_detect = grep $_ != ${$_[0]}, @post_detect; 1000 @post_detect = grep $_ != ${$_[0]}, @post_detect;
936} 1001}
937 1002
938sub detect() { 1003sub detect() {
939 unless ($MODEL) { 1004 unless ($MODEL) {
976 last; 1041 last;
977 } 1042 }
978 } 1043 }
979 1044
980 $MODEL 1045 $MODEL
981 or die "No event module selected for AnyEvent and autodetect failed. Install any one of these modules: EV, Event or Glib."; 1046 or die "No event module selected for AnyEvent and autodetect failed. Install any one of these modules: EV, Event or Glib.\n";
982 } 1047 }
983 } 1048 }
984 1049
985 push @{"$MODEL\::ISA"}, "AnyEvent::Base"; 1050 push @{"$MODEL\::ISA"}, "AnyEvent::Base";
986 1051
1016 my ($rw, $mode) = $poll eq "r" ? ($r, "<") 1081 my ($rw, $mode) = $poll eq "r" ? ($r, "<")
1017 : $poll eq "w" ? ($w, ">") 1082 : $poll eq "w" ? ($w, ">")
1018 : Carp::croak "AnyEvent->io requires poll set to either 'r' or 'w'"; 1083 : Carp::croak "AnyEvent->io requires poll set to either 'r' or 'w'";
1019 1084
1020 open my $fh2, "$mode&" . fileno $fh 1085 open my $fh2, "$mode&" . fileno $fh
1021 or die "cannot dup() filehandle: $!"; 1086 or die "cannot dup() filehandle: $!,";
1022 1087
1023 # we assume CLOEXEC is already set by perl in all important cases 1088 # we assume CLOEXEC is already set by perl in all important cases
1024 1089
1025 ($fh2, $rw) 1090 ($fh2, $rw)
1026} 1091}
1027 1092
1028package AnyEvent::Base; 1093package AnyEvent::Base;
1029 1094
1030# default implementation for now and time 1095# default implementations for many methods
1031 1096
1032BEGIN { 1097BEGIN {
1033 if (eval "use Time::HiRes (); time (); 1") { 1098 if (eval "use Time::HiRes (); Time::HiRes::time (); 1") {
1034 *_time = \&Time::HiRes::time; 1099 *_time = \&Time::HiRes::time;
1035 # if (eval "use POSIX (); (POSIX::times())... 1100 # if (eval "use POSIX (); (POSIX::times())...
1036 } else { 1101 } else {
1037 *_time = sub { time }; # epic fail 1102 *_time = sub { time }; # epic fail
1038 } 1103 }
1039} 1104}
1040 1105
1041sub time { _time } 1106sub time { _time }
1042sub now { _time } 1107sub now { _time }
1108sub now_update { }
1043 1109
1044# default implementation for ->condvar 1110# default implementation for ->condvar
1045 1111
1046sub condvar { 1112sub condvar {
1047 bless { @_ == 3 ? (_ae_cb => $_[2]) : () }, AnyEvent::CondVar:: 1113 bless { @_ == 3 ? (_ae_cb => $_[2]) : () }, "AnyEvent::CondVar"
1048} 1114}
1049 1115
1050# default implementation for ->signal 1116# default implementation for ->signal
1051 1117
1052our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO); 1118our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO);
1064 1130
1065sub signal { 1131sub signal {
1066 my (undef, %arg) = @_; 1132 my (undef, %arg) = @_;
1067 1133
1068 unless ($SIGPIPE_R) { 1134 unless ($SIGPIPE_R) {
1135 require Fcntl;
1136
1069 if (AnyEvent::WIN32) { 1137 if (AnyEvent::WIN32) {
1138 require AnyEvent::Util;
1139
1070 ($SIGPIPE_R, $SIGPIPE_W) = AnyEvent::Util::portable_pipe (); 1140 ($SIGPIPE_R, $SIGPIPE_W) = AnyEvent::Util::portable_pipe ();
1071 AnyEvent::Util::fh_nonblocking ($SIGPIPE_R) if $SIGPIPE_R; 1141 AnyEvent::Util::fh_nonblocking ($SIGPIPE_R) if $SIGPIPE_R;
1072 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W) if $SIGPIPE_W; # just in case 1142 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W) if $SIGPIPE_W; # just in case
1073 } else { 1143 } else {
1074 pipe $SIGPIPE_R, $SIGPIPE_W; 1144 pipe $SIGPIPE_R, $SIGPIPE_W;
1075 require Fcntl;
1076 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R; 1145 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R;
1077 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case 1146 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case
1147
1148 # not strictly required, as $^F is normally 2, but let's make sure...
1149 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1150 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1078 } 1151 }
1079 1152
1080 $SIGPIPE_R 1153 $SIGPIPE_R
1081 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n"; 1154 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n";
1082 1155
1086 my $signal = uc $arg{signal} 1159 my $signal = uc $arg{signal}
1087 or Carp::croak "required option 'signal' is missing"; 1160 or Carp::croak "required option 'signal' is missing";
1088 1161
1089 $SIG_CB{$signal}{$arg{cb}} = $arg{cb}; 1162 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1090 $SIG{$signal} ||= sub { 1163 $SIG{$signal} ||= sub {
1164 local $!;
1091 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV; 1165 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV;
1092 undef $SIG_EV{$signal}; 1166 undef $SIG_EV{$signal};
1093 }; 1167 };
1094 1168
1095 bless [$signal, $arg{cb}], "AnyEvent::Base::Signal" 1169 bless [$signal, $arg{cb}], "AnyEvent::Base::signal"
1096} 1170}
1097 1171
1098sub AnyEvent::Base::Signal::DESTROY { 1172sub AnyEvent::Base::signal::DESTROY {
1099 my ($signal, $cb) = @{$_[0]}; 1173 my ($signal, $cb) = @{$_[0]};
1100 1174
1101 delete $SIG_CB{$signal}{$cb}; 1175 delete $SIG_CB{$signal}{$cb};
1102 1176
1177 # delete doesn't work with older perls - they then
1178 # print weird messages, or just unconditionally exit
1179 # instead of getting the default action.
1103 delete $SIG{$signal} unless keys %{ $SIG_CB{$signal} }; 1180 undef $SIG{$signal} unless keys %{ $SIG_CB{$signal} };
1104} 1181}
1105 1182
1106# default implementation for ->child 1183# default implementation for ->child
1107 1184
1108our %PID_CB; 1185our %PID_CB;
1109our $CHLD_W; 1186our $CHLD_W;
1110our $CHLD_DELAY_W; 1187our $CHLD_DELAY_W;
1111our $PID_IDLE;
1112our $WNOHANG; 1188our $WNOHANG;
1113 1189
1114sub _child_wait { 1190sub _sigchld {
1115 while (0 < (my $pid = waitpid -1, $WNOHANG)) { 1191 while (0 < (my $pid = waitpid -1, $WNOHANG)) {
1116 $_->($pid, $?) for (values %{ $PID_CB{$pid} || {} }), 1192 $_->($pid, $?) for (values %{ $PID_CB{$pid} || {} }),
1117 (values %{ $PID_CB{0} || {} }); 1193 (values %{ $PID_CB{0} || {} });
1118 } 1194 }
1119
1120 undef $PID_IDLE;
1121}
1122
1123sub _sigchld {
1124 # make sure we deliver these changes "synchronous" with the event loop.
1125 $CHLD_DELAY_W ||= AnyEvent->timer (after => 0, cb => sub {
1126 undef $CHLD_DELAY_W;
1127 &_child_wait;
1128 });
1129} 1195}
1130 1196
1131sub child { 1197sub child {
1132 my (undef, %arg) = @_; 1198 my (undef, %arg) = @_;
1133 1199
1134 defined (my $pid = $arg{pid} + 0) 1200 defined (my $pid = $arg{pid} + 0)
1135 or Carp::croak "required option 'pid' is missing"; 1201 or Carp::croak "required option 'pid' is missing";
1136 1202
1137 $PID_CB{$pid}{$arg{cb}} = $arg{cb}; 1203 $PID_CB{$pid}{$arg{cb}} = $arg{cb};
1138 1204
1139 unless ($WNOHANG) {
1140 $WNOHANG = eval { local $SIG{__DIE__}; require POSIX; &POSIX::WNOHANG } || 1; 1205 $WNOHANG ||= eval { local $SIG{__DIE__}; require POSIX; &POSIX::WNOHANG } || 1;
1141 }
1142 1206
1143 unless ($CHLD_W) { 1207 unless ($CHLD_W) {
1144 $CHLD_W = AnyEvent->signal (signal => 'CHLD', cb => \&_sigchld); 1208 $CHLD_W = AnyEvent->signal (signal => 'CHLD', cb => \&_sigchld);
1145 # child could be a zombie already, so make at least one round 1209 # child could be a zombie already, so make at least one round
1146 &_sigchld; 1210 &_sigchld;
1147 } 1211 }
1148 1212
1149 bless [$pid, $arg{cb}], "AnyEvent::Base::Child" 1213 bless [$pid, $arg{cb}], "AnyEvent::Base::child"
1150} 1214}
1151 1215
1152sub AnyEvent::Base::Child::DESTROY { 1216sub AnyEvent::Base::child::DESTROY {
1153 my ($pid, $cb) = @{$_[0]}; 1217 my ($pid, $cb) = @{$_[0]};
1154 1218
1155 delete $PID_CB{$pid}{$cb}; 1219 delete $PID_CB{$pid}{$cb};
1156 delete $PID_CB{$pid} unless keys %{ $PID_CB{$pid} }; 1220 delete $PID_CB{$pid} unless keys %{ $PID_CB{$pid} };
1157 1221
1158 undef $CHLD_W unless keys %PID_CB; 1222 undef $CHLD_W unless keys %PID_CB;
1223}
1224
1225# idle emulation is done by simply using a timer, regardless
1226# of whether the process is idle or not, and not letting
1227# the callback use more than 50% of the time.
1228sub idle {
1229 my (undef, %arg) = @_;
1230
1231 my ($cb, $w, $rcb) = $arg{cb};
1232
1233 $rcb = sub {
1234 if ($cb) {
1235 $w = _time;
1236 &$cb;
1237 $w = _time - $w;
1238
1239 # never use more then 50% of the time for the idle watcher,
1240 # within some limits
1241 $w = 0.0001 if $w < 0.0001;
1242 $w = 5 if $w > 5;
1243
1244 $w = AnyEvent->timer (after => $w, cb => $rcb);
1245 } else {
1246 # clean up...
1247 undef $w;
1248 undef $rcb;
1249 }
1250 };
1251
1252 $w = AnyEvent->timer (after => 0.05, cb => $rcb);
1253
1254 bless \\$cb, "AnyEvent::Base::idle"
1255}
1256
1257sub AnyEvent::Base::idle::DESTROY {
1258 undef $${$_[0]};
1159} 1259}
1160 1260
1161package AnyEvent::CondVar; 1261package AnyEvent::CondVar;
1162 1262
1163our @ISA = AnyEvent::CondVar::Base::; 1263our @ISA = AnyEvent::CondVar::Base::;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines